////////////////////////////////////////////////////////////////////////////////////////////
//   actions.inc                    Version 2.0 Release                    Date: OCT/02/2004
//
//   RS All-In-One[AIO] Admin Menu
//   File: AIO Admin Command Action Routines
//
//   By:    Rob Secord
//   Alias: xeroblood (aka; sufferer)
//   Email: xeroblood@msn.com
//
//   Developed using:  AMX 0.9.9     &     AMXX 0.20
//   Modules:          Fun & Misc          Fun & Misc
//                     VexD-UM             Engine
//                                         CStrike
//   Tested On:        CS 1.6 (STEAM)
//                     Windows XP Professional
//
////////////////////////////////////////////////////////////////////////////////////////////


#if defined _AIO_ACTIONS_INCLUDED
  #endinput
#endif
#define _AIO_ACTIONS_INCLUDED



/***************************************************************************
 ********  Action Routines Section (Turns Stuff ON)  ***********************
 **************************************************************************/


public ActionBan( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionBan %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T], szUserInfo[STR_T], szCmd[STR_S]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( g_szCmdArgs[p_aCmdArgs[0]-1][0] == 0 )
        copy( g_szCmdArgs[p_aCmdArgs[0]-1], STR_T-1, "0" )

    if( equal( g_szCmdArgs[p_aCmdArgs[0]-1], "0" ) )
    {
        console_print( p_aCmdArgs[1], "You Have Been Banned Permanently!" )
        format( szMsg, STR_S-1, "%s Has Been Banned Permanently!", szUserName )
    }else
    {
        console_print( p_aCmdArgs[1], "You Have Been Banned For %s Minutes!", g_szCmdArgs[p_aCmdArgs[0]-1] )
        format( szMsg, STR_S-1, "%s Has Been Banned For %s Minutes!", szUserName, g_szCmdArgs[p_aCmdArgs[0]-1] )
    }
    AnnounceAction( p_aCmdArgs[0], szMsg )

    if( get_cvar_num( "sv_aio_ban_ip" ) )
    {
        get_user_ip( p_aCmdArgs[1], szUserInfo, STR_T-1, 1 )
        format( szCmd, STR_S-1, "addip ^"%s^" ^"%s^";wait;writeip", g_szCmdArgs[p_aCmdArgs[0]-1], szUserInfo )
    }else
    {
        get_user_authid( p_aCmdArgs[1], szUserInfo, STR_T-1 )
        format( szCmd, STR_S-1, "banid ^"%s^" ^"%s^" kick;wait;writeid", g_szCmdArgs[p_aCmdArgs[0]-1], szUserInfo )
    }

    #if defined AIO_DEBUG_MODE
        client_print( p_aCmdArgs[0], print_chat, szCmd )
    #else
        server_cmd( szCmd )
    #endif

    return
}

public ActionKick( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionKick %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )
    format( szMsg, STR_S-1, "%s Has Just Been Kicked!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )
    console_print( p_aCmdArgs[1], "You Have Been Kicked By Admin!" )

    #if defined AIO_DEBUG_MODE
        client_print( p_aCmdArgs[0], print_chat, "kick #%d", get_user_userid( p_aCmdArgs[1] ) )
    #else
        server_cmd( "kick #%d", get_user_userid( p_aCmdArgs[1] ) )
    #endif

    return
}

public ActionSlap( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionSlap %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( g_szCmdArgs[p_aCmdArgs[0]-1][0] == 0 )
        copy( g_szCmdArgs[p_aCmdArgs[0]-1], STR_T-1, "0" )

    client_print( p_aCmdArgs[1], print_chat, "You Have Been Slapped With %s Damage!", g_szCmdArgs[p_aCmdArgs[0]-1] )
    format( szMsg, STR_S-1, "%s Has Been Slapped With %s Damage!", szUserName, g_szCmdArgs[p_aCmdArgs[0]-1] )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    new aCmdArgs[3]
    aCmdArgs[0] = p_aCmdArgs[1]
    aCmdArgs[1] = str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] )
    BitchSlapPlayer( aCmdArgs )

    return
}

public ActionBitchSlap( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionBitchSlap %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    new nSlapTimes = str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] )
    new aCmdArgs[3]
    aCmdArgs[0] = p_aCmdArgs[1]
    aCmdArgs[1] = 1

    client_print( p_aCmdArgs[1], print_chat, "You Are Being Bitch-Slapped %d Times!", nSlapTimes )
    format( szMsg, STR_S-1, "%s Is Getting Bitch-Slapped %d Times!", szUserName, nSlapTimes )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    if( nSlapTimes < 2 ) nSlapTimes = 2
    set_task( 0.3, "BitchSlapPlayer", (TASK_BSLAP+p_aCmdArgs[1]), aCmdArgs, 2, "a", nSlapTimes-1 )

    return
}

public ActionBury( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        client_print( p_aCmdArgs[0], print_chat, "[DEBUG][AIO] ActionBury %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    client_print( p_aCmdArgs[1], print_chat, "You Have Been %s!", (p_aCmdArgs[2])?"Buried":"Unburied" )
    format( szMsg, STR_S-1, "%s Has Been %s!", szUserName, (p_aCmdArgs[2])?"Buried":"Unburied" )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    new nOrigin[3]
    get_user_origin( p_aCmdArgs[1], nOrigin )
    if( p_aCmdArgs[2] )
        nOrigin[2] -= 30
    else
        nOrigin[2] += 40
    set_user_origin( p_aCmdArgs[1], nOrigin )

    return
}

public ActionGag( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionGag %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_GAG )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently Gagged!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_GAG
        set_task( fTime, "UnGagPlayer", (TASK_GAG + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_GAG) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Not Currently Gagged!" )
            return
        }
        UnGagPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_GAG + p_aCmdArgs[1] ) )
            remove_task( TASK_GAG + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Have Been Gagged For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Been Gagged For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Been Ungagged!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionMute( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionMute %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_MUTE )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently Muted!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_MUTE
        set_speak( p_aCmdArgs[1], SPEAK_MUTED )
        set_task( fTime, "UnMutePlayer", (TASK_MUTE + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_MUTE) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Not Currently Muted!" )
            return
        }
        UnMutePlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_MUTE + p_aCmdArgs[1] ) )
            remove_task( TASK_MUTE + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Have Been Muted For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Been Muted For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Been Unmuted!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionWarn( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionWarn %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    client_print( p_aCmdArgs[1], print_chat, "[AIO] You Have Been Warned!" )
    format( szMsg, STR_S-1, "%s Has Been Warned!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    show_motd( p_aCmdArgs[1], g_szFileWarn, "RS AIO-Admin Warning!" )

    return
}

public ActionBlanks( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionBlanks %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_BLANKS )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently Shooting Blanks!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_BLANKS
        set_user_hitzones( p_aCmdArgs[1], 0, 0 )
        set_task( fTime, "LiveAmmoPlayer", (TASK_BLANKS + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_BLANKS) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently Shooting Live-Ammo!" )
            return
        }
        LiveAmmoPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_BLANKS + p_aCmdArgs[1] ) )
            remove_task( TASK_BLANKS + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Are Now Shooting Blanks For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Is Shooting Blanks For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Is Shooting Live-Ammo!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionFire( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionFire %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_FIRE )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently Burning!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_FIRE
        ignite_effects( p_aCmdArgs[1] )
        ignite_player( p_aCmdArgs[1] )
        set_task( fTime, "ExtinguishPlayer", (TASK_FIRE + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_FIRE) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is NOT Currently Burning!" )
            return
        }
        ExtinguishPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_FIRE + p_aCmdArgs[1] ) )
            remove_task( TASK_FIRE + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Are Now On Fire For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Is On Fire For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Been Extinguished!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionRocket( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionRocket %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    emit_sound( p_aCmdArgs[1], CHAN_WEAPON, g_szSndRocket1, 1.0, ATTN_NORM, 0, PITCH_NORM )
    set_user_maxspeed( p_aCmdArgs[1], 0.01 )
    set_task( 1.2, "RocketPlayer", (TASK_ROCKET+p_aCmdArgs[1]), p_aCmdArgs[1], 2 )

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )
    format( szMsg, STR_S-1, "%s Has Been Turned Into A Rocket!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionStrip( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionStrip %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    StripWeapons( p_aCmdArgs[1] )

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )
    format( szMsg, STR_S-1, "%s Has Been Stripped Of All Guns!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionPoison( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionPoison %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_POISON )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently Infected!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_POISON
        poison_loop( p_aCmdArgs[1] )
        set_task( fTime, "CurePlayer", (TASK_POISON + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_POISON) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is NOT Currently Infected!" )
            return
        }
        CurePlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_POISON + p_aCmdArgs[1] ) )
            remove_task( TASK_POISON + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Are Now Infected For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Is Infected For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Been Cured!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionGod( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionGod %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_GOD )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has God Mode!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_GOD
        set_user_godmode( p_aCmdArgs[1], 1 )
        set_task( fTime, "MortalizePlayer", (TASK_GOD + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_GOD) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently A Mortal!" )
            return
        }
        MortalizePlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_GOD + p_aCmdArgs[1] ) )
            remove_task( TASK_GOD + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Now Have God Mode For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has God Mode For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Is Now A Mortal!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionGrav( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionGrav %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_GRAV )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Low Gravity!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_GRAV
        set_user_gravity( p_aCmdArgs[1], g_fGravity[1] )
        set_task( fTime, "GravitizePlayer", (TASK_GRAV + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_GRAV) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Normal Gravity!" )
            return
        }
        GravitizePlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_GRAV + p_aCmdArgs[1] ) )
            remove_task( TASK_GRAV + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Now Have Low Gravity For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has LowGravity For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Normal Gravity!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionNoclip( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionNoclip %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_NOCLIP )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has No-Clip!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_NOCLIP
        set_user_noclip( p_aCmdArgs[1], 1 )
        set_task( fTime, "ClipPlayer", (TASK_NOCLIP + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_NOCLIP) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Normal Clipping!" )
            return
        }
        ClipPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_NOCLIP + p_aCmdArgs[1] ) )
            remove_task( TASK_NOCLIP + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Now Have No-Clip For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has No-Clip For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Normal Clipping!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionTurbo( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionTurbo %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_TURBO )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Turbo Mode!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        new nSpeed = get_cvar_num( "sv_aio_turbo_speed" )

        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_TURBO
        client_cmd( p_aCmdArgs[1], "cl_forwardspeed %d", nSpeed )
        g_fSpeeds[p_aCmdArgs[1]-1] = get_user_maxspeed( p_aCmdArgs[1] )
        set_user_maxspeed( p_aCmdArgs[1], float(nSpeed) )
        engclient_cmd( p_aCmdArgs[1], "weapon_knife" )
        speed_loop( p_aCmdArgs[1] )
        set_task( fTime, "SlowPlayer", (TASK_TURBO + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_TURBO) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Normal Speed!" )
            return
        }
        SlowPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_TURBO + p_aCmdArgs[1] ) )
            remove_task( TASK_TURBO + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Now Have Turbo Mode For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Turbo Mode For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Normal Speed!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionSilent( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionSilent %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_SILENT )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Silent Mode!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_SILENT
        set_task( fTime, "UnSilentPlayer", (TASK_SILENT + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_SILENT) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Makes Noise!" )
            return
        }
        UnSilentPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_SILENT + p_aCmdArgs[1] ) )
            remove_task( TASK_SILENT + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Now Have Silent Mode For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Silent Mode For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Lost Silent Mode!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionInvis( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionInvis %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_INVIS )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently Invisible!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_INVIS
        set_user_rendering( p_aCmdArgs[1], kRenderFxNone, 0,0,0, kRenderTransAdd, 5 )
        set_task( fTime, "VisiblePlayer", (TASK_INVIS + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_INVIS) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Is Currently Visible!" )
            return
        }
        VisiblePlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_INVIS + p_aCmdArgs[1] ) )
            remove_task( TASK_INVIS + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Now Have Invisibility For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Invisibility For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Lost Invisibility!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionSpy( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionSpy %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_SPY )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Looks Like Enemy!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_SPY
        new szTeam[16]
        get_user_team( p_aCmdArgs[1], szTeam, 15 )
        if( equali(szTeam, "TERRORIST") )
            PlayerSetModel( p_aCmdArgs[1], random_num(0,3), TEAM_CT )
        else
            PlayerSetModel( p_aCmdArgs[1], random_num(0,3), TEAM_T )
        set_task( fTime, "UnSpyPlayer", (TASK_SPY + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_SPY) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Looks Normal!" )
            return
        }
        UnSpyPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_SPY + p_aCmdArgs[1] ) )
            remove_task( TASK_SPY + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Now Look Like Enemy For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Looks Like Enemy For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Looks Normal!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionNades( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionNades %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_NADES )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Unlimited Grenades!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_NADES
        grenade_loop( p_aCmdArgs[1] )
        set_task( fTime, "NadelessPlayer", (TASK_NADES + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_NADES) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Limited Grenades!" )
            return
        }
        NadelessPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_NADES + p_aCmdArgs[1] ) )
            remove_task( TASK_NADES + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Have Unlimited Grenades For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Unlimited Grenades For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Limited Grenades!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionAmmo( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionAmmo %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_AMMO )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Unlimited Ammo!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_AMMO
        set_task( fTime, "AmmolessPlayer", (TASK_AMMO + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_AMMO) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Limited Ammo!" )
            return
        }
        AmmolessPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_AMMO + p_aCmdArgs[1] ) )
            remove_task( TASK_AMMO + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Have Unlimited Ammo For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Unlimited Ammo For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Limited Ammo!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionHealth( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionHealth %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( g_szCmdArgs[p_aCmdArgs[0]-1][0] == 0 )
        copy( g_szCmdArgs[p_aCmdArgs[0]-1], STR_T-1, "100" )

    client_print( p_aCmdArgs[1], print_chat, "Your HP Has Been Set To: %s!", g_szCmdArgs[p_aCmdArgs[0]-1] )
    format( szMsg, STR_S-1, "%s Has Been Set With %s HP!", szUserName, g_szCmdArgs[p_aCmdArgs[0]-1] )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    set_user_health( p_aCmdArgs[1], str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )

    return
}

public ActionArmor( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionArmor %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( g_szCmdArgs[p_aCmdArgs[0]-1][0] == 0 )
        copy( g_szCmdArgs[p_aCmdArgs[0]-1], STR_T-1, "100" )

    client_print( p_aCmdArgs[1], print_chat, "Your AP Has Been Set To: %s!", g_szCmdArgs[p_aCmdArgs[0]-1] )
    format( szMsg, STR_S-1, "%s Has Been Set With %s AP!", szUserName, g_szCmdArgs[p_aCmdArgs[0]-1] )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    set_user_armor( p_aCmdArgs[1], str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )

    return
}

public ActionRevival( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionRevival %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_REVIVE )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Instant Revival!" )
            return
        }
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_REVIVE
        g_nReviveTimes[p_aCmdArgs[1]-1] = str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_REVIVE) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Does Not Have Instant Revival!" )
            return
        }
        DeadPlayer( p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Have Instant Revival For %d Deaths!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Instant Revival For %d Deaths!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Will Stay Dead Now!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionEars( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionEars %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    if( p_aCmdArgs[2] )
    {
        if( g_nHasEffect[p_aCmdArgs[1]-1] & AIO_EARS )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Big Ears!" )
            return
        }
        new Float:fTime = float( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ) )
        g_nHasEffect[p_aCmdArgs[1]-1] |= AIO_EARS
        set_speak( p_aCmdArgs[1], SPEAK_LISTENALL )
        set_task( fTime, "DeafenPlayer", (TASK_EARS + p_aCmdArgs[1]), p_aCmdArgs[1], 1 )
    }else
    {
        if( !(g_nHasEffect[p_aCmdArgs[1]-1] & AIO_EARS) )
        {
            console_print( p_aCmdArgs[0], "[AIO] Client Currently Has Normal Ears!" )
            return
        }
        DeafenPlayer( p_aCmdArgs[1] )
        if( task_exists( TASK_EARS + p_aCmdArgs[1] ) )
            remove_task( TASK_EARS + p_aCmdArgs[1] )
    }

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Now Have Big Ears For %d Seconds!", str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
        format( szMsg, STR_S-1, "%s Has Big Ears For %d Seconds!", szUserName, str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
        format( szMsg, STR_S-1, "%s Has Lost Big Ears!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionStack( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionStack %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    client_print( 0, print_chat, "You Have Been Stacked!" )
    format( szMsg, STR_S-1, "Everyone Has Been Stacked on %s!", szUserName )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    new nOrigin[3], i, nNum
    new nPlayers[MAX_PLAYERS]
    new nOffsetY = 36, nOffsetZ = 96

    get_user_origin( p_aCmdArgs[1], nOrigin )
    get_players( nPlayers, nNum, "a" )

    if( p_aCmdArgs[2] )
        nOffsetZ = 0
    else nOffsetY = 0

    for( i = 0; i < nNum; i++ )
    {
        if( (nPlayers[i] == p_aCmdArgs[1]) || PlayerHasImmunity( nPlayers[i], MISC_CMDS ) )
            continue

        nOrigin[1] += nOffsetY
        nOrigin[2] += nOffsetZ

        set_user_origin( nPlayers[i], nOrigin )
    }
    return
}

public ActionGlow( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionGlow %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    client_print( 0, print_chat, "You Now Have A %s Glow!", g_szCmdArgs[p_aCmdArgs[0]-1] )
    format( szMsg, STR_S-1, "%s Has A %s Glow!", szUserName, g_szCmdArgs[p_aCmdArgs[0]-1] )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    new nColor
    for( nColor = 0; nColor < MAX_COLORS; nColor++ )
        if( equali(g_szCmdArgs[p_aCmdArgs[0]-1], g_szColors[nColor]) )
            break

    if( nColor == MAX_COLORS-1 ) nColor = random_num( 0, MAX_COLORS-2 )
    set_user_rendering( p_aCmdArgs[1], kRenderFxGlowShell, g_nColors[nColor][0], g_nColors[nColor][1], g_nColors[nColor][2], kRenderNormal, 30 )

    return
}

public ActionCash( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionCash %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( g_szCmdArgs[p_aCmdArgs[0]-1][0] == 0 )
        copy( g_szCmdArgs[p_aCmdArgs[0]-1], STR_T-1, "16000" )

    new nCash = clamp( str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1]), 0, 16000 )
    PlayerSetMoney( p_aCmdArgs[1], nCash )

    client_print( p_aCmdArgs[1], print_chat, "Your Cash Has Been Set To: %d!", nCash )
    format( szMsg, STR_S-1, "%s Has Been Set With %d Cash!", szUserName, nCash )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionAdmin( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionAdmin %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( p_aCmdArgs[2] )
    {
        if( g_szCmdArgs[p_aCmdArgs[0]-1][0] == 0 )
            copy( g_szCmdArgs[p_aCmdArgs[0]-1], STR_T-1, "i" )

        client_print( p_aCmdArgs[1], print_chat, "Your Priveleges Have Been Set To: %s!", g_szCmdArgs[p_aCmdArgs[0]-1] )
        format( szMsg, STR_S-1, "%s Has Been Set With %s Priveleges!", szUserName, g_szCmdArgs[p_aCmdArgs[0]-1] )
        set_user_flags( p_aCmdArgs[1], read_flags(g_szCmdArgs[p_aCmdArgs[0]-1]) )
    }else
    {
        client_print( p_aCmdArgs[1], print_chat, "Your Priveleges Have Been Removed!", g_szCmdArgs[p_aCmdArgs[0]-1] )
        format( szMsg, STR_S-1, "%s Had Priveleges Removed!", szUserName, g_szCmdArgs[p_aCmdArgs[0]-1] )
        set_user_flags( p_aCmdArgs[1], (-1) )
    }
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionFrags( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionFrags %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( g_szCmdArgs[p_aCmdArgs[0]-1][0] == 0 )
        copy( g_szCmdArgs[p_aCmdArgs[0]-1], STR_T-1, "1" )

    new nFrags = (get_user_frags( p_aCmdArgs[1] ) + str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ))
    set_user_frags( p_aCmdArgs[1], nFrags )

    client_print( p_aCmdArgs[1], print_chat, "Your Frags Have Been Set To: %d!", nFrags )
    format( szMsg, STR_S-1, "%s Has Been Set With %d Frags!", szUserName, nFrags )
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}

public ActionWeapon( p_aCmdArgs[] )
{
    #if defined AIO_DEBUG_MODE
        console_print( p_aCmdArgs[0], "[DEBUG][AIO] ActionWeapon %d %d %s", p_aCmdArgs[1], p_aCmdArgs[2], g_szCmdArgs[p_aCmdArgs[0]-1] )
    #endif

    new szMsg[STR_S], szUserName[STR_T]
    get_user_name( p_aCmdArgs[1], szUserName, STR_T-1 )

    if( g_szCmdArgs[p_aCmdArgs[0]-1][0] == 0 )
        copy( g_szCmdArgs[p_aCmdArgs[0]-1], STR_T-1, "26" )  // Default DEAGLE

    if( str_to_num(g_szCmdArgs[p_aCmdArgs[0]-1][0]) == 0 )
    {
        client_print( p_aCmdArgs[1], print_chat, "You Have Been Striped of All Weapons!" )
        format( szMsg, STR_S-1, "%s Has Been Striped of All Weapons!", szUserName )
        StripWeapons( p_aCmdArgs[1] )
    }else
    {
        new szWeaponName[STR_T]
        get_weaponname( str_to_num( g_szCmdArgs[p_aCmdArgs[0]-1] ), szWeaponName, STR_T-1 )
        give_item( p_aCmdArgs[1], szWeaponName )
        client_print( p_aCmdArgs[1], print_chat, "You Have Been Given %s!", szWeaponName[7] )
        format( szMsg, STR_S-1, "%s Has Been Given %s!", szUserName, szWeaponName[7] )
    }
    AnnounceAction( p_aCmdArgs[0], szMsg )

    return
}


/***************************************************************************
 ********  Action Routines Section (Turns Stuff OFF)  **********************
 **************************************************************************/

public BitchSlapPlayer( p_aCmdArgs[] )
    user_slap( p_aCmdArgs[0], p_aCmdArgs[1] )

public UnGagPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Been Ungagged And May Now Chat!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_GAG
}

public UnMutePlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Been Unmuted And May Now Speak!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_MUTE
    set_speak( p_aCmdArgs[0], SPEAK_NORMAL )
}

public LiveAmmoPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Are Now Shooting Live-Ammo!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_BLANKS
    set_user_hitzones( p_aCmdArgs[1], 0, 255 )
}

public ExtinguishPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Been Extinguished!" )
    if( g_nHasEffect[p_aCmdArgs[0]-1] & AIO_FIRE )
        g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_FIRE
}

public RocketPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Are Now An Explosive Rocket!" )
    set_user_gravity( p_aCmdArgs[0], -0.50 )
    client_cmd( p_aCmdArgs[0], "+jump;wait;wait;-jump" )
    emit_sound( p_aCmdArgs[0], CHAN_VOICE, g_szSndRocket2, 1.0, 0.5, 0, PITCH_NORM )
    rocket_effects( p_aCmdArgs[0] )
}

public CurePlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Been Cured Of Your Infection!" )
    if( g_nHasEffect[p_aCmdArgs[0]-1] & AIO_POISON )
        g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_POISON
}

public MortalizePlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Been Returned To Mortal State!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_GOD
    set_user_godmode( p_aCmdArgs[0], 0 )
}

public GravitizePlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Normal Gravity Now!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_GRAV
    set_user_gravity( p_aCmdArgs[0], g_fGravity[0] )
}

public ClipPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Normal Clipping Now!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_NOCLIP
    set_user_noclip( p_aCmdArgs[0], 0 )
}

public SlowPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Lost Your Turbo Speed!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_TURBO
}

public UnSilentPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Lost Your Silent Mode!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_SILENT
}

public VisiblePlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Lost Invisibility!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_INVIS
    set_user_rendering( p_aCmdArgs[0], kRenderFxNone, 255,255,255, kRenderNormal, 255 )
}

public UnSpyPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Now Look Normal!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_SPY
    PlayerSetModel( p_aCmdArgs[0], 0, AIO_EMPTY )
}

public NadelessPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Limited Grenades Again!" )
    if( g_nHasEffect[p_aCmdArgs[0]-1] & AIO_NADES )
        g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_NADES
}

public AmmolessPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Limited Ammo Again!" )
    if( g_nHasEffect[p_aCmdArgs[0]-1] & AIO_AMMO )
        g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_AMMO
}

public DeadPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Will Stay Dead Now!" )
    if( g_nHasEffect[p_aCmdArgs[0]-1] & AIO_REVIVE )
        g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_REVIVE
    g_nReviveTimes[p_aCmdArgs[0]-1] = 0
}

public DeafenPlayer( p_aCmdArgs[] )
{
    client_print( p_aCmdArgs[0], print_chat, "You Have Lost Big Ears!" )
    g_nHasEffect[p_aCmdArgs[0]-1] ^= AIO_EARS
    set_speak( p_aCmdArgs[0], SPEAK_NORMAL )
}


