////////////////////////////////////////////////////////////////////////////////////////////
//   commands.inc                    Version 2.0 Release                   Date: OCT/02/2004
//
//   RS All-In-One[AIO] Admin Menu
//   File: AIO Admin Client Commands
//
//   By:    Rob Secord
//   Alias: xeroblood (aka; sufferer)
//   Email: xeroblood@msn.com
//
//   Developed using:  AMX 0.9.9     &     AMXX 0.20
//   Modules:          Fun & Misc          Fun & Misc
//                     VexD-UM             Engine
//                                         CStrike
//   Tested On:        CS 1.6 (STEAM)
//                     Windows XP Professional
//
////////////////////////////////////////////////////////////////////////////////////////////


#if defined _AIO_COMMANDS_INCLUDED
  #endinput
#endif
#define _AIO_COMMANDS_INCLUDED



/***************************************************************************
 *******  Client Commands Section  *****************************************
 **************************************************************************/

public ClCmd_AIOMode( id, lvl, cid )
{
    if( !cmd_access( id, lvl, cid, 2 ) )
        return PLUGIN_HANDLED

    new szArg[5]
    read_argv( 1, szArg, 4 )
    new nOnOff = InputSwitch( szArg )
    set_cvar_num( "sv_aio_allow", nOnOff )
    console_print( id, "%s %s %s!", PLUGIN_MOD, PLUGIN_NAME, g_szMode[nOnOff] )

    return PLUGIN_HANDLED
}

public ClCmd_AIOHelp( id, lvl, cid )
{
    if( !cmd_access( id, lvl, cid, 1 ) )
        return PLUGIN_HANDLED

    if( !get_cvar_num( "sv_aio_allow" ) )
    {
        console_print( id, "%s %s Currently DISABLED!", PLUGIN_MOD, PLUGIN_NAME )
        console_print( id, "%s %s Use: aio_mode 1 -- To Enable!!!", PLUGIN_MOD, PLUGIN_NAME )
        return PLUGIN_HANDLED
    }

    show_motd( id, g_szFileHelp, "AIO Admin Menu Help!" )

    return PLUGIN_HANDLED
}

public ClCmd_CheckSay( id )
{
    if( g_nHasEffect[id-1] & AIO_GAG )
    {
        client_print( id, print_chat, "%s You Have Been Gagged... You Cannot Chat!", PLUGIN_MOD )
        return PLUGIN_HANDLED
    }

    new szSayCmd[STR_T]
    read_argv( 0, szSayCmd, STR_T-1 )

    new i, nNum, nPlayers[MAX_PLAYERS]
    get_players( nPlayers, nNum, "c" )

    for( i = 0; i < nNum; i++ )
    {
        if( g_nHasEffect[nPlayers[i]-1] & AIO_EARS )
        {
            if( (is_user_alive(id) != is_user_alive(nPlayers[i])) || ((get_user_team(id) != get_user_team(nPlayers[i])) && equali(szSayCmd, "say_team")) )
            {
                new szSpeech[STR_M], szPlayer[STR_T]
                read_args( szSpeech, STR_M-1 )
                get_user_name( id, szPlayer, STR_T-1 )
                client_print( nPlayers[i], print_chat, "%s {BIG-EARS} %s: %s", PLUGIN_MOD, szPlayer, szSpeech )
            }
        }
    }
    return PLUGIN_CONTINUE
}

public ClCmd_AdminCmd( id, lvl, cid )
{
    if( !cmd_access( id, lvl, cid, 3 ) )
        return PLUGIN_HANDLED

    if( !get_cvar_num( "sv_aio_allow" ) )
    {
        client_print( id, print_console, "%s %s Currently DISABLED", PLUGIN_MOD, PLUGIN_NAME )
        client_print( id, print_chat, "%s %s Currently DISABLED", PLUGIN_MOD, PLUGIN_NAME )
        return PLUGIN_HANDLED
    }

    new szCurrCmd[16]
    new nCmdIdx, nCmdType

    read_argv( 0, szCurrCmd, 15 )
    for( nCmdIdx = 0; nCmdIdx < MAX_COMMANDS; nCmdIdx++ )
        if( equali( szCurrCmd, g_szAdminCmd[nCmdIdx] ) )
            break

    if( !IsCommandEnabled( (1<<nCmdIdx) ) )
    {
        console_print( id, "%s %s Command '%s' is DISABLED!", PLUGIN_MOD, PLUGIN_NAME, g_szCmdTitle[nCmdIdx] )
        return PLUGIN_HANDLED
    }

    nCmdType = GetCommandType( nCmdIdx )

    new szArg[3][STR_T], szTemp[STR_T]
    read_args( szTemp, STR_T-1 )
    ExplodeString( szArg, 3, szTemp, STR_T-1, ' ' )

    new nOnOff = InputSwitch( szArg[1] )
    copy( g_szCmdArgs[id-1], STR_T-1, szArg[2] )

    if( szArg[0][0] == '@' )
    {
        new nNum = 0, aPlayers[MAX_PLAYERS]
        if( equali(szArg[0][1], "T") || equali(szArg[0][1], "TERRORIST") )
            get_players( aPlayers, nNum, "e", "TERRORIST" )
        else if( equali(szArg[0][1], "C") || equali(szArg[0][1], "CT") )
            get_players( aPlayers, nNum, "e", "CT" )
        else if( equali(szArg[0][1], "A") || equali(szArg[0][1], "ALL") )
            get_players( aPlayers, nNum )

        if( nNum > 0 )
        {
            for( new i = 0; i < nNum; i++ )
            {
                if( PlayerHasImmunity( aPlayers[i], nCmdType ) )
                {
                    new szAdminName[STR_T]
                    get_user_name( aPlayers[i], szAdminName, STR_T-1 )
                    console_print( id, "%s %s: Player %s Has Immunity", PLUGIN_MOD, PLUGIN_NAME, szAdminName )
                }else
                {
                    new aCmdParm[4]
                    aCmdParm[0] = id
                    aCmdParm[1] = aPlayers[i]
                    aCmdParm[2] = nOnOff

                    set_task( 0.5, g_szCmdFuntion[nCmdIdx], (TASK_COMMON + aPlayers[i]), aCmdParm, 3, "a", 0 )
                }
            }
        }else
        {
            console_print( id, "%s %s: No Clients For %s In Team: %s", PLUGIN_MOD, PLUGIN_NAME, g_szCmdTitle[nCmdIdx], szArg[0][1] )
            return  PLUGIN_HANDLED
        }

    }
    else
    {
        new nUserID = cmd_target( id, szArg[0], 7 )
        if( !nUserID )
        {
            console_print( id, "%s %s: User Could Not Be Found For %s...", PLUGIN_MOD, PLUGIN_NAME, g_szCmdTitle[nCmdIdx] )
            return PLUGIN_HANDLED
        }

        if( PlayerHasImmunity( nUserID, nCmdType ) )
        {
            new szAdminName[STR_T]
            get_user_name( nUserID, szAdminName, STR_T-1 )
            console_print( id, "%s %s: Player %s Has Immunity", PLUGIN_MOD, PLUGIN_NAME, szAdminName )
        }else
        {
            new aCmdParm[4]
            aCmdParm[0] = id
            aCmdParm[1] = nUserID
            aCmdParm[2] = nOnOff

            set_task( 0.5, g_szCmdFuntion[nCmdIdx], (TASK_COMMON + nUserID), aCmdParm, 3, "a", 0 )
        }
    }
    return PLUGIN_HANDLED
}



