////////////////////////////////////////////////////////////////////////////////////////////
//   common.inc                      Version 2.0 Release                   Date: OCT/02/2004
//
//   RS All-In-One[AIO] Admin Menu
//   File: AIO Admin Common Functions
//
//   By:    Rob Secord
//   Alias: xeroblood (aka; sufferer)
//   Email: xeroblood@msn.com
//
//   Developed using:  AMX 0.9.9     &     AMXX 0.20
//   Modules:          Fun & Misc          Fun & Misc
//                     VexD-UM             Engine
//                                         CStrike
//   Tested On:        CS 1.6 (STEAM)
//                     Windows XP Professional
//
////////////////////////////////////////////////////////////////////////////////////////////


#if defined _AIO_STOCK_INCLUDED
  #endinput
#endif
#define _AIO_STOCK_INCLUDED



stock ReadCmdFlags( p_szFlags[] )
{
    new i, j = 0
    new szBit[MAX_COMMANDS][] = { "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","1","2","3","4","5","6" }

    for( i = 0; i < MAX_COMMANDS; i++ )
        if( containi( p_szFlags, szBit[i] ) > AIO_EMPTY )
            j |= (1<<i)
    return j
}

stock GetCommandType( p_nCmdIdx )
{
    if( p_nCmdIdx < 0 ) return p_nCmdIdx
    if( p_nCmdIdx < BAD_CMDS ) return BAD_CMDS
    if( p_nCmdIdx < GOOD_CMDS ) return GOOD_CMDS
    return MISC_CMDS
}

stock bool:IsCommandEnabled( p_nCmdBit )
{
    new szFlags[MAX_COMMANDS+1]
    get_cvar_string( "sv_aio_command_flags", szFlags, MAX_COMMANDS )

    return ( ReadCmdFlags(szFlags) & p_nCmdBit ) ? true : false
}

stock bool:CmdHasCVAR( p_nCmdBit )
{
    return ( ReadCmdFlags("acdfgijmnopqrstuvwxyz3456") & p_nCmdBit ) ? true : false
}

stock bool:PlayerHasImmunity( id, p_nCmdType )
{
    switch( p_nCmdType )
    {
        case BAD_CMDS:  if( !get_cvar_num("sv_aio_immunity_bad") )  return false
        case GOOD_CMDS: if( !get_cvar_num("sv_aio_immunity_good") ) return false
        case MISC_CMDS: if( !get_cvar_num("sv_aio_immunity_misc") ) return false
    }
    if( access( id, ADMIN_IMMUNITY ) )
        return true
    return false
}

stock bool:IsPlayerAdmin( p_nUserID )
{
    new i
    for( i = 0; i < 20; i++ )
        if( access(p_nUserID, (1<<i)) ) return true
    return false
}

stock InputSwitch( p_szArg[] )
{
    return ( equali( p_szArg, "on", 2 ) || equali( p_szArg, "1", 1 ) ) ? 1 : 0
}

stock PlayerSetModel( p_nPlayerIdx, p_nModelIdx, p_nTeam )
{
#if defined USE_AMXX_MODE
    if( p_nTeam == AIO_EMPTY )
        cs_reset_user_model( p_nPlayerIdx )
    else if( p_nTeam == TEAM_T )
        cs_set_user_model( p_nPlayerIdx, g_szTSkins[p_nModelIdx] )
    else
        cs_set_user_model( p_nPlayerIdx, g_szCTSkins[p_nModelIdx] )
#else
    if( p_nTeam == AIO_EMPTY )
        CS_ClearModel( p_nPlayerIdx )
    else if( p_nTeam == TEAM_T )
        CS_SetModel( p_nPlayerIdx, g_szTSkins[p_nModelIdx] )
    else
        CS_SetModel( p_nPlayerIdx, g_szCTSkins[p_nModelIdx] )
#endif
}

stock PlayerSetMoney( p_nPlayerIdx, p_nMoney )
{
#if defined USE_AMXX_MODE
    cs_set_user_money( p_nPlayerIdx, p_nMoney )
#else
    set_user_money( p_nPlayerIdx, p_nMoney )
#endif
}

stock BuildFileDirs()
{
    new szBase[STR_M], szPath[STR_M]
    get_basedir( szBase, STR_M-1 )

#if defined USE_AMXX_MODE
    format( szPath, STR_M-1, "%s/configs/aio_html", szBase )
#else
    format( szPath, STR_M-1, "%s/config/aio_html", szBase )
#endif

    format( g_szFileHelp, STR_M-1, "%s/aio_help.htm", szPath )
    format( g_szFileWarn, STR_M-1, "%s/aio_warning.htm", szPath )

    return
}

stock ExplodeString( p_szOutput[][], p_nMax, p_szInput[], p_nSize, p_szDelimiter )
{
    new nIdx = 0, l = strlen(p_szInput)
    new nLen = (1 + copyc( p_szOutput[nIdx], p_nSize, p_szInput, p_szDelimiter ))
    while( (nLen < l) && (++nIdx < p_nMax) )
        nLen += (1 + copyc( p_szOutput[nIdx], p_nSize, p_szInput[nLen], p_szDelimiter ))
    return
}

stock StripWeapons( p_nUserID )
{
    new nWeapons[MAX_WEAPONS], nNum
    new szWeaponName[STR_T]
    new nOrigin[3]

    get_user_origin( p_nUserID, nOrigin )
    nOrigin[2] -= 1024
    set_user_origin( p_nUserID, nOrigin )

    get_user_weapons( p_nUserID, nWeapons, nNum )
    for( new i = 0; i < nNum; i++ )
    {
        get_weaponname( nWeapons[i], szWeaponName, STR_T-1 )
        engclient_cmd( p_nUserID, "drop", szWeaponName )
    }
    engclient_cmd( p_nUserID, "weapon_knife" )

    nOrigin[2] += 1028
    set_user_origin( p_nUserID, nOrigin )

    return
}

stock AnnounceAction( p_nAdminID, p_szAction[] )
{
    new szAdminName[STR_T]
    get_user_name( p_nAdminID, szAdminName, (STR_T-1) )
    show_activity( p_nAdminID, szAdminName, p_szAction )
    return
}