////////////////////////////////////////////////////////////////////////////////////////////
//   const.inc                       Version 2.0 Release                   Date: OCT/02/2004
//
//   RS All-In-One[AIO] Admin Menu
//   File: AIO Admin Constant Defines
//
//   By:    Rob Secord
//   Alias: xeroblood (aka; sufferer)
//   Email: xeroblood@msn.com
//
//   Developed using:  AMX 0.9.9     &     AMXX 0.20
//   Modules:          Fun & Misc          Fun & Misc
//                     VexD-UM             Engine
//                                         CStrike
//   Tested On:        CS 1.6 (STEAM)
//                     Windows XP Professional
//
////////////////////////////////////////////////////////////////////////////////////////////


#if defined _AIO_CONST_INCLUDED
  #endinput
#endif
#define _AIO_CONST_INCLUDED



// Plugin Information
#define PLUGIN_NAME      "AIO Admin Menu"
#define PLUGIN_VERSION   "2.0"
#define PLUGIN_AUTHOR   "xeroblood"
#if defined USE_AMXX_MODE
    #define PLUGIN_MOD   "[AMXX]"
#else
    #define PLUGIN_MOD   "[AMX]"
#endif

// Max Values
#define MAX_COMMANDS  32
#define MAX_PLAYERS   32
#define MAX_WEAPONS   32
#define MAX_CMD_CVARS 9
#define MAX_COLORS    8

// CS Teams
#define TEAM_T          0
#define TEAM_CT         1

// String Sizes
#define STR_T 32
#define STR_S 64
#define STR_M 128
#define STR_L 256
#define STR_X 512

// Command Offsets
#define BAD_CMDS  13
#define GOOD_CMDS 26
#define MISC_CMDS 32

// Menu Specific Settings
#define MENU_SIZE    256
#define MENU_DISPLAY 8

// set_task IDs
#define TASK_COMMON     1000
#define TASK_BSLAP      1100
#define TASK_GAG        1200
#define TASK_MUTE       1300
#define TASK_BLANKS     1400
#define TASK_FIRE       1500
#define TASK_ROCKET     1600
#define TASK_POISON     1700
#define TASK_GOD        1800
#define TASK_GRAV       1900
#define TASK_NOCLIP     2000
#define TASK_TURBO      2100
#define TASK_SILENT     2200
#define TASK_INVIS      2300
#define TASK_SPY        2400
#define TASK_NADES      2500
#define TASK_AMMO       2600
#define TASK_REVIVE     2700
#define TASK_EARS       2800


#define AIO_EMPTY   (-1)

// Bad Commands
#define AIO_BAN     (1<<0)
#define AIO_KICK    (1<<1)
#define AIO_SLAP    (1<<2)
#define AIO_BSLAP   (1<<3)
#define AIO_BURY    (1<<4)
#define AIO_GAG     (1<<5)
#define AIO_MUTE    (1<<6)
#define AIO_WARN    (1<<7)
#define AIO_BLANKS  (1<<8)
#define AIO_FIRE    (1<<9)
#define AIO_ROCKET  (1<<10)
#define AIO_STRIP   (1<<11)
#define AIO_POISON  (1<<12)

// Good Commands
#define AIO_GOD     (1<<13)
#define AIO_GRAV    (1<<14)
#define AIO_NOCLIP  (1<<15)
#define AIO_TURBO   (1<<16)
#define AIO_SILENT  (1<<17)
#define AIO_INVIS   (1<<18)
#define AIO_SPY     (1<<19)
#define AIO_NADES   (1<<20)
#define AIO_AMMO    (1<<21)
#define AIO_HP      (1<<22)
#define AIO_AP      (1<<23)
#define AIO_REVIVE  (1<<24)
#define AIO_EARS    (1<<25)

// Misc Commands
#define AIO_STACK   (1<<26)
#define AIO_GLOW    (1<<27)
#define AIO_CASH    (1<<28)
#define AIO_ADMIN   (1<<29)
#define AIO_FRAG    (1<<30)
#define AIO_WEAPON  (1<<31)
