////////////////////////////////////////////////////////////////////////////////////////////
//   effects.inc                     Version 2.0 Release                   Date: OCT/02/2004
//
//   RS All-In-One[AIO] Admin Menu
//   File: AIO Admin Special Command Effects
//
//   By:    Rob Secord
//   Alias: xeroblood (aka; sufferer)
//   Email: xeroblood@msn.com
//
//   Developed using:  AMX 0.9.9     &     AMXX 0.20
//   Modules:          Fun & Misc          Fun & Misc
//                     VexD-UM             Engine
//                                         CStrike
//   Tested On:        CS 1.6 (STEAM)
//                     Windows XP Professional
//
////////////////////////////////////////////////////////////////////////////////////////////


#if defined _AIO_EFFECTS_INCLUDED
  #endinput
#endif
#define _AIO_EFFECTS_INCLUDED



/***************************************************************************
 ********  Respawn Control for Revival  ************************************
 **************************************************************************/

public RevivePlayer( p_aCmdArgs[] )
{
    if( get_user_team( p_aCmdArgs[0] ) == 3 || is_user_alive( p_aCmdArgs[0] ) )
        return PLUGIN_CONTINUE

    entity_set_int( p_aCmdArgs[0], EV_INT_deadflag, 3 )
    DispatchSpawn( p_aCmdArgs[0] )

    return PLUGIN_CONTINUE
}

/***************************************************************************
 ********  Speed Loop  *****************************************************
 **************************************************************************/

public speed_loop( p_aCmdArgs[] )
{
    if( g_nHasEffect[p_aCmdArgs[0]-1] & AIO_TURBO )
    {
        new nSpeed = get_cvar_num( "sv_aio_turbo_speed" )
        set_user_maxspeed( p_aCmdArgs[0], float(nSpeed) )
        set_task( 1.0, "speed_loop", 0, p_aCmdArgs, 2 )
    }else
    {
        client_cmd( p_aCmdArgs[0], "cl_forwardspeed 400" )
        set_user_maxspeed( p_aCmdArgs[0], g_fSpeeds[p_aCmdArgs[0]-1] )
        g_fSpeeds[p_aCmdArgs[0]-1] = 0.0
        engclient_cmd( p_aCmdArgs[0], "weapon_knife" )
    }
    return
}

/***************************************************************************
 ********  Unlimited Grenade Loop  *****************************************
 **************************************************************************/

public grenade_loop( p_aCmdArgs[] )
{
    new vID = p_aCmdArgs[0]
    if( is_user_alive(vID) && (g_nHasEffect[vID-1] & AIO_NADES) )
    {
        new i, nNum, nWeapon[32]
        new bool:hasNade = false
        get_user_weapons( vID, nWeapon, nNum )

        for( i = 0; i < nNum; i++ )
        {
            if( nWeapon[i] == CSW_HEGRENADE )
            {
                hasNade = true
                break
            }
        }
        if( !hasNade ) give_item( vID, "weapon_hegrenade" )

        set_task( 1.0, "grenade_loop", 0, p_aCmdArgs, 2 )
    }
    else
    {
        if( g_nHasEffect[vID-1] & AIO_NADES )
            NadelessPlayer( p_aCmdArgs )
    }
    return PLUGIN_CONTINUE
}

/***************************************************************************
 ********  Fire Effects By f117bomb (Slightly Modified)  *******************
 **************************************************************************/

public ignite_effects( skIndex[] )
{
    new kIndex = skIndex[0]

    if( is_user_alive(kIndex) && (g_nHasEffect[kIndex-1] & AIO_FIRE) )
    {
        new korigin[3]
        get_user_origin( kIndex, korigin )

        //TE_SPRITE - additive sprite, plays 1 cycle
        message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
        write_byte( 17 )
        write_coord( korigin[0] )  // coord, coord, coord (position)
        write_coord( korigin[1] )
        write_coord( korigin[2] )
        write_short( g_sprMFlash ) // short (sprite index)
        write_byte( 20 )           // byte (scale in 0.1's)
        write_byte( 200 )          // byte (brightness)
        message_end()

        //Smoke
        message_begin( MSG_BROADCAST, SVC_TEMPENTITY, korigin )
        write_byte( 5 )
        write_coord( korigin[0] )  // coord coord coord (position)
        write_coord( korigin[1] )
        write_coord( korigin[2] )
        write_short( g_sprSmoke )  // short (sprite index)
        write_byte( 20 )           // byte (scale in 0.1's)
        write_byte( 15 )           // byte (framerate)
        message_end()

        set_task( 0.2, "ignite_effects", 0, skIndex, 2 )
    }
    else
    {
        if( g_nHasEffect[kIndex-1] & AIO_FIRE )
        {
            emit_sound( kIndex, CHAN_AUTO, g_szSndScream2, 0.6, ATTN_NORM, 0, PITCH_HIGH )
            g_nHasEffect[kIndex-1] ^= AIO_FIRE
        }
    }
    return PLUGIN_CONTINUE
}

public ignite_player( skIndex[] )
{
    new kIndex = skIndex[0]

    if( is_user_alive(kIndex) && (g_nHasEffect[kIndex-1] & AIO_FIRE) )
    {
        new korigin[3]
        new players[32], inum = 0
        new pOrigin[3]
        new kHealth = get_user_health( kIndex )
        new nDmgAmount = get_cvar_num( "sv_aio_fire_damage" )
        get_user_origin( kIndex, korigin )

        //create some damage
        set_user_health( kIndex, (kHealth - nDmgAmount) )

        message_begin( MSG_ONE, g_nMsgDamage, {0,0,0}, kIndex )
        write_byte( 30 )          // dmg_save
        write_byte( 30 )          // dmg_take
        write_long( 1<<21 )       // visibleDamageBits
        write_coord( korigin[0] ) // damageOrigin.x
        write_coord( korigin[1] ) // damageOrigin.y
        write_coord( korigin[2] ) // damageOrigin.z
        message_end()

        //create some sound
        emit_sound( kIndex, CHAN_ITEM, g_szSndFlames, 0.6, ATTN_NORM, 0, PITCH_NORM )

        //Ignite Others
        get_players( players, inum, "a" )
        for( new i = 0; i < inum; ++i )
        {
            get_user_origin( players[i], pOrigin )
            if( get_distance( korigin, pOrigin ) < 100  )
            {
                if( !(g_nHasEffect[players[i]-1] & AIO_FIRE) )
                {
                    new spIndex[2]
                    spIndex[0] = players[i]
                    new pName[32], kName[32]
                    get_user_name( players[i], pName, 31 )
                    get_user_name( kIndex, kName, 31 )
                    emit_sound( players[i], CHAN_WEAPON, g_szSndScream1, 1.0, ATTN_NORM, 0, PITCH_HIGH )
                    client_print( 0, print_chat, "[AIO] OH NO! %s has caught %s on fire!", kName, pName )
                    g_nHasEffect[players[i]-1] |= AIO_FIRE
                    ignite_player( players[i] )
                    ignite_effects( players[i] )
                }
            }
        }
        players[0] = 0
        pOrigin[0] = 0
        korigin[0] = 0

        //Call Again in 2 seconds
        set_task( 2.0, "ignite_player", 0, skIndex, 2 )
    }

    return PLUGIN_CONTINUE
}

/***************************************************************************
 ********  Rocket Effects By f117bomb (Slightly Modified)  *****************
 **************************************************************************/

public rocket_effects( svictim[] )
{
    new victim = svictim[0]

    if( is_user_alive(victim) )
    {
        new vorigin[3]
        get_user_origin( victim, vorigin )

        message_begin( MSG_ONE, g_nMsgDamage, {0,0,0}, victim )
        write_byte( 30 )          // dmg_save
        write_byte( 30 )          // dmg_take
        write_long( 1<<16 )       // visibleDamageBits
        write_coord( vorigin[0] ) // damageOrigin.x
        write_coord( vorigin[1] ) // damageOrigin.y
        write_coord( vorigin[2] ) // damageOrigin.z
        message_end()

        if( g_nRocket_Z[victim-1] == vorigin[2] )
            rocket_explode( svictim )
        g_nRocket_Z[victim-1] = vorigin[2]

        //Draw Trail and effects
        //TE_SPRITETRAIL - line of moving glow sprites with gravity, fadeout, and collisions
        message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
        write_byte( 15 )
        write_coord( vorigin[0] )        // coord, coord, coord (start)
        write_coord( vorigin[1] )
        write_coord( vorigin[2] )
        write_coord( vorigin[0] )        // coord, coord, coord (end)
        write_coord( vorigin[1] )
        write_coord( vorigin[2] - 30 )
        write_short( g_sprBFlare )       // short (sprite index)
        write_byte( 5 )                  // byte (count)
        write_byte( 1 )                  // byte (life in 0.1's)
        write_byte( 1 )                  // byte (scale in 0.1's)
        write_byte( 10 )                 // byte (velocity along vector in 10's)
        write_byte( 5 )                  // byte (randomness of velocity in 10's)
        message_end()

        //TE_SPRITE - additive sprite, plays 1 cycle
        message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
        write_byte( 17 )
        write_coord( vorigin[0] )        // coord, coord, coord (position)
        write_coord( vorigin[1] )
        write_coord( vorigin[2] - 30 )
        write_short( g_sprMFlash )       // short (sprite index)
        write_byte( 15 )                 // byte (scale in 0.1's)
        write_byte( 255 )                // byte (brightness)
        message_end()

        set_task( 0.2, "rocket_effects", 0, svictim, 2 )
    }
    return PLUGIN_CONTINUE
}

public rocket_explode( svictim[] )
{
    new victim = svictim[0]

    if( is_user_alive(victim) ) /*If user is alive create effects and user_kill */
    {
        new vec1[3]
        get_user_origin( victim, vec1 )

        // blast circles
        message_begin( MSG_BROADCAST, SVC_TEMPENTITY, vec1 )
        write_byte( 21 )
        write_coord( vec1[0] )
        write_coord( vec1[1] )
        write_coord( vec1[2] - 10 )
        write_coord( vec1[0] )
        write_coord( vec1[1] )
        write_coord( vec1[2] + 1910 )
        write_short( g_sprWhite )
        write_byte( 0 )              // startframe
        write_byte( 0 )              // framerate
        write_byte( 2 )              // life
        write_byte( 16 )             // width
        write_byte( 0 )              // noise
        write_byte( 188 )            // r
        write_byte( 220 )            // g
        write_byte( 255 )            // b
        write_byte( 255 )            //brightness
        write_byte( 0 )              // speed
        message_end()

        //Explosion2
        message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
        write_byte( 12 )
        write_coord( vec1[0] )
        write_coord( vec1[1] )
        write_coord( vec1[2] )
        write_byte( 188 )            // byte (scale in 0.1's)
        write_byte( 10 )             // byte (framerate)
        message_end()

        //Smoke
        message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
        write_byte( 5 )
        write_coord(vec1[0])
        write_coord(vec1[1])
        write_coord(vec1[2])
        write_short( g_sprSmoke )
        write_byte( 2 )
        write_byte( 10 )
        message_end()

        user_kill( victim, 1 )
    }

    //stop_sound
    emit_sound( victim, CHAN_VOICE, g_szSndRocket2, 0.0, 0.0, (1<<5), PITCH_NORM )

    set_user_maxspeed( victim, 1.0 )
    set_user_gravity( victim, 1.00 )

    return PLUGIN_CONTINUE
}

/***************************************************************************
 ********  Poison Effects By AssKicR (Slightly Modified)  ******************
 **************************************************************************/

public poison_loop( p_aCmdArgs[] )
{
    new vID = p_aCmdArgs[0]
    if( is_user_alive(vID) && (g_nHasEffect[vID-1] & AIO_POISON) )
    {
        new userHealth = get_user_health( vID )
        new nDmgAmount = get_cvar_num( "sv_aio_poison_damage" )
        new nNewHP = (userHealth - nDmgAmount)
        set_user_health( vID, nNewHP )
        if( nNewHP < 1 )
        {
            message_begin( MSG_BROADCAST, g_nMsgDeath, {0,0,0}, 0 )
            write_byte( vID )
            write_byte( vID )
            write_byte( 0 )
            write_string( "infection" )
            message_end()
        }

        new korigin[3]
        get_user_origin( vID, korigin )
        message_begin( MSG_ONE, g_nMsgDamage, {0,0,0}, vID )
        write_byte( 30 )             // dmg_save
        write_byte( 30 )             // dmg_take
        write_long( 1 << 16 )        // visibleDamageBits
        write_coord( korigin[0] )    // damageOrigin.x
        write_coord( korigin[1] )    // damageOrigin.y
        write_coord( korigin[2] )    // damageOrigin.z
        message_end()

        emit_sound( vID, CHAN_AUTO, g_szSndPoison, 0.6, ATTN_NORM, 0, PITCH_HIGH )

        set_task( 1.0, "poison_loop", 0, p_aCmdArgs, 2 )
    }
    else
    {
        if( g_nHasEffect[vID-1] & AIO_POISON )
        {
            emit_sound( vID, CHAN_AUTO, g_szSndScream2, 0.6, ATTN_NORM, 0, PITCH_HIGH )
            g_nHasEffect[vID-1] ^= AIO_POISON
        }
    }
    return PLUGIN_CONTINUE
}


