////////////////////////////////////////////////////////////////////////////////////////////
//   events.inc                      Version 2.0 Release                   Date: OCT/02/2004
//
//   RS All-In-One[AIO] Admin Menu
//   File: AIO Admin Hooked Events
//
//   By:    Rob Secord
//   Alias: xeroblood (aka; sufferer)
//   Email: xeroblood@msn.com
//
//   Developed using:  AMX 0.9.9     &     AMXX 0.20
//   Modules:          Fun & Misc          Fun & Misc
//                     VexD-UM             Engine
//                                         CStrike
//   Tested On:        CS 1.6 (STEAM)
//                     Windows XP Professional
//
////////////////////////////////////////////////////////////////////////////////////////////


#if defined _AIO_EVENTS_INCLUDED
  #endinput
#endif
#define _AIO_EVENTS_INCLUDED



/***************************************************************************
 ********  Event Routines Section  *****************************************
 **************************************************************************/

public Event_DeathMsg()
{
    if( !get_cvar_num( "sv_aio_allow" ) )
        return PLUGIN_HANDLED

    new id = read_data(2)

    if( task_exists( TASK_BSLAP + id ) )  remove_task( TASK_BSLAP + id )
    if( task_exists( TASK_FIRE + id ) )   remove_task( TASK_FIRE + id )
    if( task_exists( TASK_POISON + id ) ) remove_task( TASK_POISON + id )

    if( g_nHasEffect[id-1] & AIO_BSLAP )  g_nHasEffect[id-1] ^= AIO_BSLAP
    if( g_nHasEffect[id-1] & AIO_FIRE )   g_nHasEffect[id-1] ^= AIO_FIRE
    if( g_nHasEffect[id-1] & AIO_POISON ) g_nHasEffect[id-1] ^= AIO_POISON

    if( g_nHasEffect[id-1] & AIO_REVIVE )
    {
        new aCmdArgs[2]
        aCmdArgs[0] = id

        if( g_nReviveTimes[id-1] > 0 )
        {
            g_nReviveTimes[id-1]--
            client_print( id, print_chat, "Revival Lives Left: %d", g_nReviveTimes[id-1] )
            set_task( 0.5, "RevivePlayer", (TASK_REVIVE + id), aCmdArgs, 1 )
        }else
            DeadPlayer( aCmdArgs )
    }else
    {
        // Unrevived players lose GOOD effects..
        if( task_exists( TASK_NADES + id ) )  remove_task( TASK_NADES + id )
        if( task_exists( TASK_AMMO + id ) )   remove_task( TASK_AMMO + id )

        if( g_nHasEffect[id-1] & AIO_NADES )  g_nHasEffect[id-1] ^= AIO_NADES
        if( g_nHasEffect[id-1] & AIO_AMMO )   g_nHasEffect[id-1] ^= AIO_AMMO
    }
    return PLUGIN_CONTINUE
}

public Event_NewRound( id )
{
    if( !get_cvar_num( "sv_aio_allow" ) )
        return PLUGIN_HANDLED

    if( task_exists( TASK_BSLAP + id ) )  remove_task( TASK_BSLAP + id )
    if( task_exists( TASK_FIRE + id ) )   remove_task( TASK_FIRE + id )
    if( task_exists( TASK_POISON + id ) ) remove_task( TASK_POISON + id )
    if( task_exists( TASK_NADES + id ) )  remove_task( TASK_NADES + id )

    if( g_nHasEffect[id-1] & AIO_BSLAP )  g_nHasEffect[id-1] ^= AIO_BSLAP
    if( g_nHasEffect[id-1] & AIO_FIRE )   g_nHasEffect[id-1] ^= AIO_FIRE
    if( g_nHasEffect[id-1] & AIO_POISON ) g_nHasEffect[id-1] ^= AIO_POISON
    if( g_nHasEffect[id-1] & AIO_NADES )  g_nHasEffect[id-1] ^= AIO_NADES

    return PLUGIN_CONTINUE
}

public Event_ChgWeapon( id )
{
    if( !get_cvar_num( "sv_aio_allow" ) ) return PLUGIN_CONTINUE
    if( !IsCommandEnabled( AIO_AMMO ) ) return PLUGIN_CONTINUE
    if ( !(g_nHasEffect[id-1] & AIO_AMMO) ) return PLUGIN_CONTINUE

    new  nClip, nAmmo
    new nWeaponID = get_user_weapon( id, nClip, nAmmo )

    switch( nWeaponID )
    {
        case CSW_C4: return PLUGIN_CONTINUE
        case CSW_HEGRENADE: return PLUGIN_CONTINUE
        case CSW_SMOKEGRENADE: return PLUGIN_CONTINUE
        case CSW_FLASHBANG: return PLUGIN_CONTINUE
        case CSW_KNIFE: return PLUGIN_CONTINUE
    }

    new szWeaponName[STR_T]
    if( nClip == 0 )
    {
        get_weaponname( nWeaponID, szWeaponName, STR_T-1 )
        //engclient_cmd( id, "drop", szWeaponName )
        give_item( id, szWeaponName )
        engclient_cmd( id, szWeaponName )
    }
    return PLUGIN_CONTINUE
}


