////////////////////////////////////////////////////////////////////////////////////////////
//   global.inc                      Version 2.0 Release                   Date: OCT/02/2004
//
//   RS All-In-One[AIO] Admin Menu
//   File: AIO Admin Global Variables
//
//   By:    Rob Secord
//   Alias: xeroblood (aka; sufferer)
//   Email: xeroblood@msn.com
//
//   Developed using:  AMX 0.9.9     &     AMXX 0.20
//   Modules:          Fun & Misc          Fun & Misc
//                     VexD-UM             Engine
//                                         CStrike
//   Tested On:        CS 1.6 (STEAM)
//                     Windows XP Professional
//
////////////////////////////////////////////////////////////////////////////////////////////


#if defined _AIO_GLOBAL_INCLUDED
  #endinput
#endif
#define _AIO_GLOBAL_INCLUDED



new g_szMode[2][] = { "DISABLED", "ENABLED" }
new g_szColors[MAX_COLORS][] = { "Red", "Green", "Blue", "Cyan", "Magenta", "Yellow", "Orange", "Random" }
new g_nColors[MAX_COLORS][] =
{
    {255, 0, 0},    // Red
    {0, 255, 0},    // Green
    {0, 0, 255},    // Blue
    {0, 255, 255},  // Cyan
    {255, 0, 255},  // Magenta
    {255, 255, 0},  // Yellow
    {255, 153, 0},  // Orange
    {0, 0, 0}       // Not Used (Random)
}

// CS Player Models
new g_szCTSkins[4][] = { "sas", "gsg9", "urban", "gign" }
new g_szTSkins[4][] =  { "arctic", "leet", "guerilla", "terror" }

// Gravity Setting (1.0 = 800 = Normal Gravity)
new Float:g_fGravity[] = { 1.0, 0.25 }

// Current Player Command/Effect
new g_szCmdArgs[MAX_PLAYERS][STR_T]
new g_nHasEffect[MAX_PLAYERS]
new g_nReviveTimes[MAX_PLAYERS]

// Client Messages (HL Engine)
new g_nMsgDamage
new g_nMsgDeath

// Sprites
new g_sprWhite
new g_sprSmoke
new g_sprMFlash
new g_sprBFlare

// Specific Command Variables
new g_nRocket_Z[MAX_PLAYERS]
new Float:g_fSpeeds[MAX_PLAYERS]

// Menu Variables
new g_nMenuPlayers[MAX_PLAYERS][MAX_PLAYERS]
new g_nMenuPlayersNum[MAX_PLAYERS]
new g_nMenuPosition[MAX_PLAYERS]
new g_nMenuOrder[MAX_PLAYERS]
new g_nCurrPlayer[MAX_PLAYERS]
new g_nCurrCommand[MAX_PLAYERS]
new g_nCurrType[MAX_PLAYERS]

// HTML Files For Help/Warn MOTDs
new g_szFileWarn[STR_M]
new g_szFileHelp[STR_M]

// Sound Files
new g_szSndFlames[]  = "ambience/flameburst1.wav"
new g_szSndScream1[] = "scientist/scream07.wav"
new g_szSndScream2[] = "scientist/scream21.wav"
new g_szSndRocket1[] = "weapons/rocketfire1.wav"
new g_szSndRocket2[] = "weapons/rocket1.wav"
new g_szSndPoison[]  = "player/bhit_kevlar-1.wav"

// Command Arrays
new g_szCmdTitle[MAX_COMMANDS][] =
{
    "Ban",       "Kick",       "Slap",       "Bitch Slap",  "Bury",        "Gag",         "Mute",
    "Warn",      "Blanks",     "Fire",       "Rocket",      "Strip Guns",  "Poison",
    "God Mode",  "Low Gravity","No-Clip",    "Turbo",       "Silent Mode", "Invisibility","Chameleon",
    "Free Nades","Free Ammo",  "Health",     "Armor",       "Revival",     "Big-Ears",
    "Stack",     "Glow",       "Cash-Editor","Admin-Editor","Frags-Editor","Weapon-Editor"
}
new g_szAdminCVAR[MAX_COMMANDS][] =
{
    "sv_aio_ban",       "_",       "sv_aio_slap",  "sv_aio_bslap",      "_",       "sv_aio_gag",  "sv_aio_mute",
         "_",      "sv_aio_blanks","sv_aio_fire",       "_",       "sv_aio_strip", "sv_aio_poison",
    "sv_aio_god",  "sv_aio_grav",  "sv_aio_noclip","sv_aio_turbo", "sv_aio_silent","sv_aio_invis","sv_aio_spy",
    "sv_aio_nades","sv_aio_ammo",  "sv_aio_health","sv_aio_armor", "sv_aio_revive","sv_aio_ears",
         "_",           "_",       "sv_aio_cash",  "sv_aio_admin", "sv_aio_frags", "sv_aio_weapon"
}
new g_szAdminCmd[MAX_COMMANDS][] =
{
    "aio_ban",  "aio_kick",  "aio_slap",  "aio_bslap", "aio_bury",  "aio_gag",  "aio_mute",
    "aio_warn", "aio_blanks","aio_fire",  "aio_rocket","aio_strip", "aio_poison",
    "aio_god",  "aio_grav",  "aio_noclip","aio_turbo", "aio_silent","aio_invis","aio_spy",
    "aio_nades","aio_ammo",  "aio_health","aio_armor", "aio_revive","aio_ears",
    "aio_stack","aio_glow",  "aio_cash",  "aio_admin", "aio_frags", "aio_weapon"
}
new g_szCmdFuntion[MAX_COMMANDS][] =
{
    "ActionBan",  "ActionKick",  "ActionSlap",  "ActionBitchSlap","ActionBury",   "ActionGag",  "ActionMute",
    "ActionWarn", "ActionBlanks","ActionFire",  "ActionRocket",   "ActionStrip",  "ActionPoison",
    "ActionGod",  "ActionGrav",  "ActionNoclip","ActionTurbo",    "ActionSilent", "ActionInvis","ActionSpy",
    "ActionNades","ActionAmmo",  "ActionHealth","ActionArmor",    "ActionRevival","ActionEars",
    "ActionStack","ActionGlow",  "ActionCash",  "ActionAdmin",    "ActionFrags",  "ActionWeapon"
}




