////////////////////////////////////////////////////////////////////////////////////////////
//   menus.inc                      Version 2.0 Release                    Date: OCT/02/2004
//
//   RS All-In-One[AIO] Admin Menu
//   File: AIO Admin Menu System
//
//   By:    Rob Secord
//   Alias: xeroblood (aka; sufferer)
//   Email: xeroblood@msn.com
//
//   Developed using:  AMX 0.9.9     &     AMXX 0.20
//   Modules:          Fun & Misc          Fun & Misc
//                     VexD-UM             Engine
//                                         CStrike
//   Tested On:        CS 1.6 (STEAM)
//                     Windows XP Professional
//
////////////////////////////////////////////////////////////////////////////////////////////


#if defined _AIO_MENUS_INCLUDED
  #endinput
#endif
#define _AIO_MENUS_INCLUDED



/***************************************************************************
 ********  Menu Routines Section  ******************************************
 **************************************************************************/

public ClCmd_AIOMenu( id, lvl, cid )
{
    if( !cmd_access( id, lvl, cid, 1 ) )
        return PLUGIN_HANDLED

    if( !get_cvar_num( "sv_aio_allow" ) )
    {
        client_print( id, print_console, "[AMX] AIO-Admin Currently DISABLED" )
        client_print( id, print_chat, "[AMX] AIO-Admin Currently DISABLED" )
        return PLUGIN_HANDLED
    }

    #if defined AIO_DEBUG_MENU
        client_print( id, print_chat, "[DEBUG] ClCmd_AIOMenu Called! (Starts Menu)" )
    #endif

    g_nMenuOrder[id-1] = (get_cvar_num("sv_aio_menu_start")) ? 1 : 0
    g_nCurrCommand[id-1] = AIO_EMPTY
    g_nCurrPlayer[id-1] = AIO_EMPTY
    g_nCurrType[id-1] = AIO_EMPTY

    if( g_nMenuOrder[id-1] )
        Menu_AIOPlayer( id, g_nMenuPosition[id-1] = 0 )
    else
        Menu_AIOCommandType( id )

    return PLUGIN_HANDLED
}

public Menu_AIOPlayer( id, pos )
{
    #if defined AIO_DEBUG_MENU
        client_print( id, print_chat, "[DEBUG] Menu_AIOPlayer Called!" )
        client_print( id, print_chat, "[DEBUG] [Player:%d][Command:%d][Type:%d]", g_nCurrPlayer[id-1], g_nCurrCommand[id-1], g_nCurrType[id-1] )
    #endif

    if( pos < 0 ) return

    g_nCurrPlayer[id-1] = AIO_EMPTY

    get_players( g_nMenuPlayers[id-1], g_nMenuPlayersNum[id-1] )

    new i, j, nCurrKey = 0
    new szUserName[STR_T]
    new szMenuBody[MENU_SIZE]
    new nStart = pos * MENU_DISPLAY

    if( nStart >= g_nMenuPlayersNum[id-1] )
        nStart = pos = g_nMenuPosition[id-1] = 0

    new nLen = format( szMenuBody, MENU_SIZE-1, "\yAIO Player Menu\R%d/%d^n\w^n", (pos+1), (g_nMenuPlayersNum[id-1] / MENU_DISPLAY + ((g_nMenuPlayersNum[id-1] % MENU_DISPLAY) ? 1 : 0 )) )
    new nEnd = nStart + MENU_DISPLAY
    new nKeys = (1<<9)

    if( nEnd > g_nMenuPlayersNum[id-1] )
        nEnd = g_nMenuPlayersNum[id-1]

    for( i = nStart; i < nEnd; i++ )
    {
        j = g_nMenuPlayers[id-1][i]
        get_user_name( j, szUserName, STR_T-1 )

        if( ((g_nCurrType[id-1] != AIO_EMPTY) && PlayerHasImmunity( j, g_nCurrType[id-1] )) || !is_user_alive(j) )
        {
            nCurrKey++
            nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "\d%d. %s^n\w", nCurrKey, szUserName )
        }else
        {
            nKeys |= (1<<nCurrKey++)
            nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "%d. %s^n", nCurrKey, szUserName )
        }
    }

    if( nEnd != g_nMenuPlayersNum[id-1] )
    {
        if( g_nMenuOrder[id-1]  )
            format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n9. More...^n0. %s", (pos)?"Back":"Exit" )
        else
            format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n9. More...^n0. Back" )
        nKeys |= (1<<8)
    }
    else
    {
        if( g_nMenuOrder[id-1]  )
            format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n0. %s", (pos)?"Back":"Exit" )
        else
            format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n0. Back" )
    }
    show_menu( id, nKeys, szMenuBody )

    return
}

public Menu_AIOCommandType( id )
{
    #if defined AIO_DEBUG_MENU
        client_print( id, print_chat, "[DEBUG] Menu_AIOCommandType Called!" )
        client_print( id, print_chat, "[DEBUG] [Player:%d][Command:%d][Type:%d]", g_nCurrPlayer[id-1], g_nCurrCommand[id-1], g_nCurrType[id-1] )
    #endif

    g_nCurrCommand[id-1] = AIO_EMPTY
    g_nCurrType[id-1] = AIO_EMPTY
    g_nMenuPosition[id-1] = 0

    new nKeys = (1<<9)
    new szMenuBody[MENU_SIZE]
    new nLen = format( szMenuBody, MENU_SIZE-1, "\yAIO Command Types\w^n" )

    if( (g_nCurrPlayer[id-1] != AIO_EMPTY) )
    {
        if( PlayerHasImmunity(g_nCurrPlayer[id-1], BAD_CMDS) )
        {
            nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\d1. Evil-Admin Commands" )
        }else
        {
            nKeys |= (1<<0)
            nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\w1. Evil-Admin Commands" )
        }

        if( PlayerHasImmunity(g_nCurrPlayer[id-1], GOOD_CMDS) )
        {
            nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\d2. Good-Admin Commands" )
        }else
        {
            nKeys |= (1<<1)
            nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\w2. Good-Admin Commands" )
        }

        if( PlayerHasImmunity(g_nCurrPlayer[id-1], MISC_CMDS) )
        {
            nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\d3. Misc-Admin Commands" )
        }else
        {
            nKeys |= (1<<2)
            nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\w3. Misc-Admin Commands" )
        }
    }else
    {
        nKeys |= ((1<<0)|(1<<1)|(1<<2))
        nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\w1. Evil-Admin Commands" )
        nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\w2. Nice-Admin Commands" )
        nLen += format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n\w3. Misc-Admin Commands" )
    }
    format( szMenuBody[nLen], MENU_SIZE-1-nLen, "^n^n0. %s", (g_nMenuOrder[id-1])?"Back":"Exit" )

    show_menu( id, nKeys, szMenuBody )

    return
}

public Menu_AIOCommand( id, pos )
{
    #if defined AIO_DEBUG_MENU
        client_print( id, print_chat, "[DEBUG] Menu_AIOCommand Called!" )
        client_print( id, print_chat, "[DEBUG] [Player:%d][Command:%d][Type:%d]", g_nCurrPlayer[id-1], g_nCurrCommand[id-1], g_nCurrType[id-1] )
    #endif

    g_nCurrCommand[id-1] = AIO_EMPTY

    new i, nCurrKey = 0
    new nKeys = (1<<9)
    new nStart, nEnd
    new szMenuBody[MENU_SIZE]
    new nLen = format( szMenuBody, MENU_SIZE-1, "\yAIO Command Menu\R%d/%d^n\w^n", (pos+1), (g_nCurrType[id-1]==MISC_CMDS)?2:1 )

    switch( g_nCurrType[id-1] )
    {
        case BAD_CMDS: nStart = (pos * MENU_DISPLAY)
        case GOOD_CMDS: nStart = ((pos * MENU_DISPLAY) + BAD_CMDS)
        case MISC_CMDS: nStart = ((pos * MENU_DISPLAY) + GOOD_CMDS)
    }
    nEnd = (nStart + MENU_DISPLAY)
    if( nEnd > g_nCurrType[id-1] ) nEnd = g_nCurrType[id-1]

    for( i = nStart; i < nEnd; i++ )
    {
        if( !IsCommandEnabled( (1<<i) ) )
        {
            nCurrKey++
            nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "\d%d. %s^n", nCurrKey, g_szCmdTitle[i] )
        }else
        {
            nKeys |= (1<<nCurrKey++)
            nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "\w%d. %s^n", nCurrKey, g_szCmdTitle[i] )
        }
    }

    if( nEnd != g_nCurrType[id-1] )
    {
        nKeys |= (1<<8)
        format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n\w9. More...^n0. Back" )
    }else
        format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n\w0. Back" )

    show_menu( id, nKeys, szMenuBody )

    return
}

public Menu_AIOSettings( id )
{
    #if defined AIO_DEBUG_MENU
        client_print( id, print_chat, "[DEBUG] Menu_AIOSettings Called!" )
        client_print( id, print_chat, "[DEBUG] [Player:%d][Command:%d][Type:%d]", g_nCurrPlayer[id-1], g_nCurrCommand[id-1], g_nCurrType[id-1] )
    #endif

    g_nMenuPosition[id-1] = 0

    new szMenuBody[MENU_SIZE]
    new i, nKeys, nLen = format( szMenuBody, MENU_SIZE-1, "\yAIO Settings Menu\w^n" )

    if( CmdHasCVAR( (1<<g_nCurrCommand[id-1]) ) )
    {
        nKeys = (1<<9)
        new szSetting[MAX_CMD_CVARS][STR_T]
        new szCvarVal[STR_S]
        new szWeaponName[STR_T], nWeaponID

        get_cvar_string( g_szAdminCVAR[g_nCurrCommand[id-1]], szCvarVal, STR_S-1 )
        ExplodeString( szSetting, MAX_CMD_CVARS, szCvarVal, STR_S-1, ' ' )

        for( i = 0; i < MAX_CMD_CVARS; i++ )
        {
            if( szSetting[i][0] != 0 )
            {
                nKeys |= (1<<i)
                if( (1<<g_nCurrCommand[id-1]) == AIO_WEAPON )
                {
                    nWeaponID = str_to_num(szSetting[i])
                    if( nWeaponID > 0 )
                        get_weaponname( nWeaponID, szWeaponName, STR_T-1 )
                    else
                        copy( szWeaponName, STR_T-1, "None!" )
                    nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n\w%d. %s", (i+1), szWeaponName )
                }else
                {
                    nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n\w%d. %s", (i+1), szSetting[i] )
                }
            }else
                break
        }
        format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n^n\w0. Back" )

        show_menu( id, nKeys, szMenuBody )

    }else if( (1<<g_nCurrCommand[id-1]) & AIO_BURY )
    {
        nKeys = ((1<<0)|(1<<1)|(1<<9))
        nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n\w1. Bury" )
        nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n\w2. Unbury" )
        format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n^n\w0. Back" )

        show_menu( id, nKeys, szMenuBody )

    }else if( (1<<g_nCurrCommand[id-1]) & AIO_GLOW )
    {
        nKeys = (1<<9)
        for( i = 0; i < MAX_COLORS; i++ )
        {
            nKeys |= (1<<i)
            nLen += format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n\w%d. %s", (i+1), g_szColors[i] )
        }
        format( szMenuBody[nLen], (MENU_SIZE-1-nLen), "^n^n\w0. Back" )

        show_menu( id, nKeys, szMenuBody )
    }else
    {
        client_cmd( id, "%s #%d on", g_szAdminCmd[g_nCurrCommand[id-1]], get_user_userid(g_nCurrPlayer[id-1]) )

        if( g_nMenuOrder[id-1] )
            Menu_AIOCommandType( id )
        else
            Menu_AIOPlayer( id, g_nMenuPosition[id-1] = 0 )
    }
    return
}

public Menu_AIONext( id, key )
{
    if( g_nMenuOrder[id-1] && (g_nCurrPlayer[id-1] == AIO_EMPTY) ) // Picked a player 1st
    {
        switch( key )
        {
            case 8: Menu_AIOPlayer( id, ++g_nMenuPosition[id-1] )
            case 9: Menu_AIOPlayer( id, --g_nMenuPosition[id-1] )
            default:
            {
                g_nCurrPlayer[id-1] = g_nMenuPlayers[id-1][g_nMenuPosition[id-1] * MENU_DISPLAY + key]
                Menu_AIOCommandType( id )
            }
        }
    }
    else if( g_nMenuOrder[id-1] && (g_nCurrPlayer[id-1] != AIO_EMPTY) ) // Picked a command 2nd
    {
        switch( key )
        {
            case 8: Menu_AIOCommand( id, ++g_nMenuPosition[id-1] )
            case 9:
            {
                if( g_nMenuPosition[id-1] )
                    Menu_AIOCommand( id, --g_nMenuPosition[id-1] )
                else
                    Menu_AIOCommandType( id )
            }
            default:
            {
                switch( g_nCurrType[id-1] )
                {
                    case BAD_CMDS:  g_nCurrCommand[id-1] = 0
                    case GOOD_CMDS: g_nCurrCommand[id-1] = BAD_CMDS
                    case MISC_CMDS: g_nCurrCommand[id-1] = GOOD_CMDS
                }
                g_nCurrCommand[id-1] += (g_nMenuPosition[id-1] * MENU_DISPLAY + key)
                Menu_AIOSettings( id )
            }
        }
    }
    else if( !g_nMenuOrder[id-1] && (g_nCurrCommand[id-1] == AIO_EMPTY) ) // Picked a command 1st
    {
        switch( key )
        {
            case 8: Menu_AIOCommand( id, ++g_nMenuPosition[id-1] )
            case 9:
            {
                if( g_nMenuPosition[id-1] )
                    Menu_AIOCommand( id, --g_nMenuPosition[id-1] )
                else
                    Menu_AIOCommandType( id )
            }
            default:
            {
                switch( g_nCurrType[id-1] )
                {
                    case BAD_CMDS:  g_nCurrCommand[id-1] = 0
                    case GOOD_CMDS: g_nCurrCommand[id-1] = BAD_CMDS
                    case MISC_CMDS: g_nCurrCommand[id-1] = GOOD_CMDS
                }
                g_nCurrCommand[id-1] += (g_nMenuPosition[id-1] * MENU_DISPLAY + key)
                Menu_AIOPlayer( id, g_nMenuPosition[id-1] = 0 )
            }
        }
    }
    else if( !g_nMenuOrder[id-1] && (g_nCurrCommand[id-1] != AIO_EMPTY) ) // Picked a player 2nd
    {
        switch( key )
        {
            case 8: Menu_AIOPlayer( id, ++g_nMenuPosition[id-1] )
            case 9:
            {
                if( g_nMenuPosition[id-1] )
                    Menu_AIOPlayer( id, --g_nMenuPosition[id-1] )
                else
                    Menu_AIOCommandType( id )
            }
            default:
            {
                g_nCurrPlayer[id-1] = g_nMenuPlayers[id-1][g_nMenuPosition[id-1] * MENU_DISPLAY + key]
                Menu_AIOSettings( id )
            }
        }
    }
    return
}

public Menu_AIOType( id, key )
{
    switch( key )
    {
        case 0: g_nCurrType[id-1] = BAD_CMDS
        case 1: g_nCurrType[id-1] = GOOD_CMDS
        case 2: g_nCurrType[id-1] = MISC_CMDS
        case 9:
        {
            if( g_nMenuOrder[id-1] )
                Menu_AIOPlayer( id, g_nMenuPosition[id-1] = 0 )
            return
        }
    }
    Menu_AIOCommand( id, g_nMenuPosition[id-1] = 0 )
}

public Menu_AIOAction( id, key )
{
    if( key == 9 )
    {
        if( g_nMenuOrder[id-1] )
            Menu_AIOCommandType( id )
        else
            Menu_AIOPlayer( id, g_nMenuPosition[id-1] = 0 )
        return
    }

    if( CmdHasCVAR( (1<<g_nCurrCommand[id-1]) ) )
    {
        new szSetting[MAX_CMD_CVARS][STR_T], szCvarVal[STR_S]

        get_cvar_string( g_szAdminCVAR[g_nCurrCommand[id-1]], szCvarVal, STR_S-1 )
        ExplodeString( szSetting, MAX_CMD_CVARS, szCvarVal, STR_S-1, ' ' )

        client_cmd( id, "%s #%d on %s", g_szAdminCmd[g_nCurrCommand[id-1]], get_user_userid(g_nCurrPlayer[id-1]), szSetting[key] )

    }else if( (1<<g_nCurrCommand[id-1]) & AIO_BURY )
    {
        client_cmd( id, "%s #%d %d", g_szAdminCmd[g_nCurrCommand[id-1]], get_user_userid(g_nCurrPlayer[id-1]), (key)?0:1 )

    }else if( (1<<g_nCurrCommand[id-1]) & AIO_GLOW )
    {
        client_cmd( id, "%s #%d on %s", g_szAdminCmd[g_nCurrCommand[id-1]], get_user_userid(g_nCurrPlayer[id-1]), g_szColors[key] )
    }

    if( g_nMenuOrder[id-1] )
        Menu_AIOCommandType( id )
    else
        Menu_AIOPlayer( id, g_nMenuPosition[id-1] = 0 )

    return
}


